unit clearaction;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, actnlist, stdctrls;

Type

  { TClearAction }

  TClearAction = Class(TAction)
  Public
    function HandlesTarget(Target: TObject): Boolean; override;
    procedure UpdateTarget(Target: TObject); override;
    procedure ExecuteTarget(Target: TObject); override;
  end;

implementation


{ TClearAction }

function TClearAction.HandlesTarget(Target: TObject): Boolean;
begin
  Result:=(Target is TCustomEdit) and (TCustomEdit(Target).Focused)
end;

procedure TClearAction.UpdateTarget(Target: TObject);
begin
  Enabled:=(TCustomEdit(Target).Text<>'')
end;

procedure TClearAction.ExecuteTarget(Target: TObject);
begin
  If (Target is TCustomEdit) then
    (Target as TCustomEdit).Clear;
end;

end.

