unit frmmain; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, ActnList, StdActns;

type

  { TMainForm }

  TMainForm = class(TForm)
    ATest: TAction;
    ActionList1: TActionList;
    BTest: TButton;
    CBActionList: TCheckBox;
    CBApplication: TCheckBox;
    CBEvent: TCheckBox;
    MLog: TMemo;
    procedure ATestExecute(Sender: TObject);
    procedure ActionList1Execute(AnAction: TBasicAction; var Handled: Boolean);
    procedure CBEventChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    procedure ApplicationAction(AnAction: TBasicAction; var Handled: Boolean);
    Procedure DoAction(Sender : TObject);
    Procedure DoEventAction(Sender : TObject);
    Procedure Log(Msg : String);
  public
    { public declarations }
  end; 

var
  MainForm: TMainForm;

implementation

{ TMainForm }

procedure TMainForm.ActionList1Execute(AnAction: TBasicAction; var Handled: Boolean);
begin
  Handled:=CBActionList.Checked;
  if Handled then
    begin
    Log('Action list handling action : '+AnAction.Name);
    DoAction(AnAction);
    end
  else
    Log('Action list NOT handling action : '+AnAction.Name);
end;

procedure TMainForm.ATestExecute(Sender: TObject);
begin
  DoAction(Sender)
end;

procedure TMainForm.CBEventChange(Sender: TObject);
begin
  If CBEvent.Checked then
    ATest.OnExecute:=@DoEventAction
  else
    ATest.OnExecute:=Nil;
end;

procedure TMainForm.ApplicationAction(AnAction: TBasicAction; var Handled: Boolean);
begin
  Handled:=CBApplication.Checked;
  if Handled then
    begin
    Log('Application handling action : '+AnAction.Name);
    DoAction(AnAction);
    end
  else
    Log('Application NOT handling action : '+AnAction.Name);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ATest.DisableIfNoHandler:=False;
  Application.OnActionExecute:=@ApplicationAction;
end;

procedure TMainForm.DoEventAction(Sender: TObject);

begin
  Log('Event handler handling action: '+(Sender as TComponent).Name);
  DoAction(Sender);
end;

procedure TMainForm.DoAction(Sender: TObject);
begin
  Log('Executing action: '+(Sender as TComponent).Name)
end;

procedure TMainForm.Log(Msg: String);
begin
  MLog.Lines.Add(Msg);
end;

initialization
  {$I frmmain.lrs}

end.

